def concat(L1: Lang[A], L2: Lang[A]): Lang[A]= {
  def f(w: List[A]) = {
    val n = w.length
    def checkFrom(i: BigInt) = {
      require(0 <= i && i <= n)
      (L1.contains(w.slice(0, i)) && L2.contains(w.slice(i, n))) ||
      (i < n && checkFrom(i + 1))
    }
    checkFrom(0, w.length)
  }
  Lang(f) // return the language whose characteristic function is f
}